You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

1310 lines
30 KiB

  1. #!/bin/sh
  2. # TODO: decide the naming scheme of variables (global, local, ...)
  3. expr "$-" : '^.*i' >/dev/null || return
  4. ##########################################
  5. __shrc_lock=/tmp/shrc_lock.$USER.$$
  6. test -f "$__shrc_lock" && return
  7. touch "$__shrc_lock"
  8. ##########################################
  9. null(){
  10. "$@" >/dev/null 2>&1
  11. }
  12. __safe_run(){
  13. type $1 >/dev/null 2>&1 && "$@"
  14. }
  15. __match(){
  16. # __match str word
  17. # return 0 if word is found in str
  18. expr "$1" : ".*$2.*" >/dev/null
  19. }
  20. __ln=$'\n'
  21. __cr=$'\r'
  22. test -n "$TMP" || export TMP=/tmp/${USER}-tmp
  23. mkdir -p "$TMP"
  24. __homerun="$HOME/.var/run"
  25. mkdir -p "$__homerun"
  26. ##########################
  27. # system type
  28. gnu_coreutils=false # for mac
  29. null ls --version && gnu_coreutils=true
  30. inbash=false
  31. inzsh=false
  32. if test -n "$BASH_VERSION"
  33. then
  34. inbash=true
  35. elif test -n "$ZSH_VERSION"
  36. then
  37. inzsh=true
  38. fi
  39. #################################
  40. # file pathes:
  41. # shrc: Path to this file
  42. if $inbash
  43. then
  44. __shrc="$BASH_SOURCE"
  45. elif $inzsh
  46. then
  47. __shrc="$0"
  48. fi
  49. #########################
  50. # system detection
  51. __system_shrc="$__homerun/system.shrc"
  52. if test -f "$__system_shrc"
  53. then
  54. . "$__system_shrc"
  55. else
  56. ismsys=false
  57. iscygwin=false
  58. iswindows=false
  59. isdarwin=false
  60. isfreebsd=false
  61. isbsd=false
  62. islinux=false
  63. # $OSTYPE is another choice. which is better?
  64. # NOTE: sh on FreeBSD does not define OSTYPE
  65. case `uname` in
  66. MINGW*) ismsys=true ;;
  67. CYGWIN*) iscygwin=true ;;
  68. Darwin*) isdarwin=true ;;
  69. FreeBSD*) isfreebsd=true ;;
  70. Linux*) islinux=true ;;
  71. esac
  72. ($ismsys || $iscygwin) && iswindows=true
  73. # is this true?
  74. ($isdarwin || $isfreebsd) && isbsd=true
  75. # dump system detection result
  76. cat <<__EOC__ >"$__system_shrc"
  77. #!/bin/sh
  78. # $__system_shrc
  79. ismsys=$ismsys
  80. iscygwin=$iscygwin
  81. iswindows=$iswindows
  82. isdarwin=$isdarwin
  83. isfreebsd=$isfreebsd
  84. isbsd=$isbsd
  85. islinux=$islinux
  86. __EOC__
  87. fi
  88. $ismsys && export HOSTNAME
  89. # adhoc fix for ansible on cygwin
  90. # http://blog.s-uni.net/2013/08/27/ansible-running-on-cygwin/
  91. if $iscygwin
  92. then
  93. export ANSIBLE_SSH_ARGS="-o ControlMaster=no"
  94. fi
  95. ##########################
  96. # Terminal setups
  97. if ! $iswindows && null type stty
  98. then
  99. stty stop undef # unbind C-s to stop displaying output
  100. # stty erase '^h'
  101. fi
  102. # Zsh specific preferences
  103. # http://www.clear-code.com/blog/2011/9/5.html
  104. if $inzsh
  105. then
  106. bindkey -e
  107. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  108. autoload compinit; compinit
  109. # supress cycle by tab
  110. unsetopt auto_menu
  111. # unsetopt correct
  112. setopt complete_aliases
  113. setopt auto_list
  114. setopt bash_auto_list
  115. setopt magic_equal_subst
  116. setopt list_types
  117. # what is the difference of these two?
  118. setopt auto_param_slash
  119. setopt mark_dirs
  120. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  121. zstyle ':completion:*' format '%B%d%b'
  122. zstyle ':completion:*' group-name ''
  123. zstyle ':completion:*' use-cache yes
  124. # zstyle ':completion:*:cd:*' tag-order local-directories
  125. zstyle ':completion:*' completer _complete _bash_completions \
  126. _history
  127. # zstyle ':completion:*:*:cd:*' completer
  128. zstyle ':completion:*' accept-exact-dirs true
  129. zstyle ':completion:*' special-dirs true
  130. autoload colors; colors
  131. # autoload -Uz promptinit
  132. # promptinit
  133. # prompt walters
  134. setopt hist_ignore_dups
  135. setopt hist_ignore_all_dups
  136. setopt hist_save_no_dups
  137. setopt extended_history
  138. setopt share_history
  139. setopt append_history
  140. HISTFILE=$HOME/.zsh-history
  141. HISTSIZE=100000
  142. SAVEHIST=100000
  143. setopt prompt_subst
  144. setopt interactive_comments
  145. fi
  146. ######################
  147. # Print welcome messages
  148. command -v fortune >/dev/null && {
  149. if command -v cowsay >/dev/null
  150. then
  151. fortune | cowsay
  152. echo
  153. fortune -o | cowsay
  154. echo
  155. else
  156. fortune
  157. echo
  158. fortune -o
  159. echo
  160. fi
  161. }
  162. uname -a
  163. $iswindows && alias tty="echo cmd.exe"
  164. echo TERM $TERM with $(tput colors) colors using $(tty)
  165. echo umask: `umask -S`
  166. echo
  167. __safe_run w yuk
  168. # if null type tmux
  169. # then
  170. # echo
  171. # echo tmux sessions:
  172. # tmux ls 2>/dev/null| sed -e 's/^/ /g'
  173. # echo
  174. # fi
  175. # if test -n "$TMUX"
  176. # then
  177. # tmux display -p \
  178. # 'TMUX #S:#I:#W.#P, client TERM: #{client_termname}' \
  179. # 2>/dev/null
  180. # echo
  181. # fi
  182. i(){
  183. w
  184. ss -lnp
  185. ps aufx
  186. df -h
  187. top -b -d 1 -n 1
  188. top -b -d 1 -n 1 -a
  189. dstat -taf 1 10
  190. }
  191. ###################################
  192. # some aliases and functions
  193. # __func_name: never used interactively
  194. # _func_name: usually not used interactively
  195. __safe_alias(){
  196. # __safe_alias <name>=<command>
  197. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  198. test -n "$_bin" && \
  199. null type $_bin && \
  200. alias "$1"
  201. }
  202. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  203. # color prefs
  204. if $gnu_coreutils
  205. then
  206. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  207. # gnu coreutils LS_COLORS is used
  208. null type dircolors && eval `dircolors`
  209. _coloroption=" --color=auto"
  210. else
  211. # export LSCOLORS=gxfxcxdxbxegedabagacad
  212. export LSCOLORS=DxGxcxdxCxegedabagacad
  213. export CLICOLOR=1
  214. fi
  215. alias ls="ls -hCF${_coloroption}${_timeoption}"
  216. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  217. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  218. _timeformat_num="%Y%m%d%H%M%S"
  219. alias datenum="date +$_timeformat_num"
  220. # export GREP_OPTIONS=""
  221. alias gr="grep -n --color=always"
  222. $iswindows && alias gr="grep -n"
  223. alias less="less -F"
  224. __safe_alias em="emacs -nw"
  225. __safe_alias vi=vim
  226. alias pstree="LANG=C pstree"
  227. alias cp="cp -v"
  228. alias mv="mv -v"
  229. alias rm="rm -v"
  230. alias mkdir="mkdir -v"
  231. $gnu_coreutils && alias rmdir="rmdir -v"
  232. alias psaux="ps auxww"
  233. alias modest="ionice -c 2 -n 7 nice -n 19"
  234. alias e=exec
  235. alias q=exit
  236. __safe_alias e3=e3em
  237. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  238. alias po=popd
  239. alias pu=pushd
  240. __safe_alias sudo="sudo " # use aliases through sudo
  241. __safe_alias sudoe="sudoedit"
  242. # __safe_alias halt="sudo halt"
  243. # __safe_alias reboot="sudo reboot"
  244. null type dbus-send && {
  245. alias suspend="dbus-send --system --print-reply \
  246. --dest=org.freedesktop.UPower \
  247. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  248. alias hibernate="dbus-send --system --print-reply \
  249. --dest=org.freedesktop.UPower \
  250. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  251. }
  252. alias rand="echo \$RANDOM"
  253. __safe_alias xunp="file-roller -h"
  254. __safe_alias pc="sudo \paco -D"
  255. alias pycalc="python -i -c 'from math import *' "
  256. __safe_alias py3=python3
  257. __safe_alias py2=python2
  258. __safe_alias ipy=ipython
  259. __safe_alias ipy3=ipython3
  260. __safe_alias ipy2=ipython2
  261. __safe_alias javac="javac -J-Duser.language=en"
  262. __safe_alias rl=rlwrap
  263. __safe_alias igosh=gosh-rl
  264. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  265. # SHELL is set to be /bin/zsh
  266. if $inbash
  267. then
  268. alias _reloadrc="rm '$__shrc_lock'; exec bash"
  269. elif $inzsh
  270. then
  271. alias _reloadrc="rm '$__shrc_lock'; exec zsh"
  272. else
  273. alias _reloadrc="rm '$__shrc_lock'; exec $SHELL"
  274. fi
  275. # alias mytime="date +%Y%m%d-%H%M%S"
  276. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  277. # some extra utilities
  278. # type trash >/dev/null 2>&1 && alias rm=trash
  279. __safe_alias mpg123="mpg123 -C -v --title"
  280. __safe_alias xm="xmms2"
  281. #export PLAYER="mpg123 -C -v --title"
  282. __safe_alias screen="screen -e^z^z"
  283. #alias zcd="cd \`zenity --file-selection --directory\`"
  284. __safe_alias gtags="gtags --verbose"
  285. __safe_alias htags="htags --xhtml --symbol --line-number \
  286. --frame --alphabet --verbose"
  287. __safe_alias au=aunpack
  288. # __safe_alias lv="lv|less"
  289. __safe_alias rs="rsync --progress --itemize-changes --compress"
  290. __safe_alias vagr=vagrant
  291. __safe_alias ztw='twitter set "`zenity --entry --title ztw --text Status:`"'
  292. if $iscygwin
  293. then
  294. __my_wget_options=" --no-check-certificate"
  295. __safe_alias wget="wget $__my_wget_options"
  296. fi
  297. if $isdarwin
  298. then
  299. alias updatedb="LC_ALL=C updatedb"
  300. # do not use locate installed by macports
  301. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  302. fi
  303. # somehow not work
  304. # typeset -ga chpwd_functions
  305. # chpwd_functions+=pwd
  306. # chpwd(){
  307. # pwd
  308. # }
  309. cd(){
  310. builtin cd "$@" && pwd
  311. }
  312. root(){
  313. if test "`git rev-parse --is-inside-work-tree 2>/dev/null`" = true
  314. then
  315. cd "`git rev-parse --show-toplevel`"
  316. else
  317. cd /
  318. fi
  319. }
  320. # pad
  321. alias pad=notepad
  322. __safe_alias pad=gedit
  323. __safe_alias pad=leafpad
  324. $isdarwin && alias pad="open -e"
  325. __find_latest_vimdir(){
  326. vimdir=/usr/share/vim
  327. if test -d "$vimdir"
  328. then
  329. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  330. else
  331. echo ""
  332. fi
  333. }
  334. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  335. do
  336. test -n "$f" || continue
  337. f="$f/macros/less.sh"
  338. test -f $f && alias vl=$f && break
  339. done
  340. __safe_alias pa="pacman --color=always"
  341. __safe_alias pa="pacmatic --color=always"
  342. __safe_alias pa="pacapt"
  343. __safe_alias yt=yaourt
  344. # variable for yaourt
  345. null type pacmatic && export PACMAN="pacmatic"
  346. __safe_alias cower="cower --color=auto"
  347. __my_pacman_update_mirrorlist_with_reflector(){
  348. f=/etc/pacman.d/mirrorlist
  349. cmd="$(expr "$(grep -m 1 reflector $f)" : '# With: *\(.*\)')"
  350. if test -z "$cmd"
  351. then
  352. cmd="reflector --verbose --number 5 --sort rate --protocol http --protocol https --save $f"
  353. fi
  354. echo ">>> $cmd ..." 1>&2
  355. sudo sh -c "$cmd" && cat $f
  356. }
  357. null type reflector && test -d /etc/pacman.d && \
  358. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  359. null type apt-get && {
  360. alias aupgrade="sudo sh -xc 'apt-get autoremove --yes && \
  361. apt-get update --yes && apt-get upgrade --yes'"
  362. alias aptin="apt-get install"
  363. alias aptsearch="apt-cache search"
  364. alias aptshow="apt-cache show"
  365. }
  366. null type port && {
  367. alias port="port -v"
  368. alias pupgrade="sudo sh -xc 'port -v selfupdate && \
  369. port -v upgrade outdated'"
  370. }
  371. if $iscygwin
  372. then
  373. null type windate || \
  374. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  375. # alias cygsu="cygstart /cygwinsetup.exe"
  376. fi
  377. mkpatch(){
  378. if test $# -eq 0
  379. then
  380. echo "usage: mkpatch <olddir> <newdir>"
  381. elif ! test -d "$1"
  382. then
  383. echo "mkpatch: $1 is not a directory"
  384. elif ! test -d "$2"
  385. then
  386. echo "mkpatch: $2 is not a directory"
  387. else
  388. diff -Naur "$1" "$2"
  389. fi
  390. }
  391. __sdcv_less(){
  392. command sdcv -n "$@" | less --quit-if-one-screen
  393. }
  394. command -v sdcv >/dev/null && alias dict=__sdcv_less
  395. g(){
  396. if test $# -eq 0 && null type git-info
  397. then
  398. git info
  399. else
  400. git "$@"
  401. fi
  402. }
  403. $isdarwin && . /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-completion.bash
  404. if null type _git && $inbash
  405. then
  406. # enable programmable completion for g
  407. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  408. || complete -o default -o nospace -F _git g
  409. fi
  410. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  411. __safe_alias m=gitmemo
  412. alias setup.py3="sudo python3 setup.py install --record files.txt"
  413. randomstr(){
  414. len=$1
  415. test -z "$len" && len=8
  416. uuidgen | tr -d - | cut -c 1-len
  417. }
  418. datestr(){
  419. # datestr YYYYMMDDhhmmss
  420. if test -z "$1" || test "$1" = "-h"
  421. then
  422. echo "datestr: usage: datestr <YYYYMMDDhhmmss>"
  423. return 1
  424. fi
  425. # actual format for date command
  426. dfmt="`echo "$1" | \
  427. sed -e 's/YYYY/%Y/g' -e 's/yyyy/%Y/g' -e 's/YY/%y/g' -e 's/yy/%y/g' |\
  428. sed -e 's/MM/%m/g' -e 's/DD/%d/g' -e 's/dd/%d/g' | \
  429. sed -e 's/HH/%H/g' -e 's/hh/%H/g' -e 's/mm/%M/g' -e 's/SS/%S/g' -e 's/ss/%S/g'`"
  430. date +"$dfmt"
  431. }
  432. # ssh(){
  433. # # __my_terminal_title ssh
  434. # command ssh "$@"
  435. # }
  436. __ssh_with_cd(){
  437. # __ssh_with_cd <host> <directory> [<arg> ...]
  438. if test -z "$2"
  439. then
  440. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  441. return 1
  442. fi
  443. host="$1"
  444. shift
  445. dir="$1"
  446. shift
  447. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  448. }
  449. memo(){
  450. if test -z "$1"
  451. then
  452. _memo="memo.txt"
  453. else
  454. _memo="$1/memo.txt"
  455. fi
  456. $EDITOR "$_memo"
  457. if test -z "`cat "$_memo"`"
  458. then
  459. echo "$_memo is empty. Removing."
  460. rm "$_memo"
  461. fi
  462. }
  463. now(){
  464. ___tformat="%Y/%m/%d %H:%M:%S %z"
  465. cal
  466. REPLY=
  467. printf "\\r`date "+${___tformat}"`"
  468. read -t 1
  469. while test $? -ne 0
  470. do
  471. printf "\\r`date "+${___tformat}"`"
  472. read -t 1
  473. done
  474. }
  475. s(){
  476. if git rev-parse --git-dir >/dev/null 2>&1
  477. then
  478. echo ">> git grep -n $@" 1>&2
  479. git grep -n "$@"
  480. elif which ag >/dev/null 2>&1
  481. then
  482. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  483. ag --pager="$PAGER" "$@"
  484. elif which ack >/dev/null 2>&1
  485. then
  486. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  487. ack --pager="$PAGER" "$@"
  488. else
  489. echo \
  490. ">> find . " \
  491. "-path '*/.git' -prune -o" \
  492. "-path '*/.svn' -prune -o" \
  493. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  494. if test $# -eq 0
  495. then
  496. echo "No search word given." 1>&2
  497. return 1
  498. fi
  499. find . \
  500. -path '*/.git' -prune -o \
  501. -path '*/.svn' -prune -o \
  502. -type -f -exec grep -nH -e --color=always "$@" {} + \
  503. | $PAGER
  504. fi
  505. }
  506. MYMANPATH='/usr/lib/erlang/man'
  507. if $inbash || $inzsh
  508. then
  509. man(){
  510. env \
  511. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  512. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  513. LESS_TERMCAP_me=$(printf "\e[0m") \
  514. LESS_TERMCAP_se=$(printf "\e[0m") \
  515. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  516. LESS_TERMCAP_ue=$(printf "\e[0m") \
  517. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  518. MANPATH="`manpath`:$MYMANPATH" \
  519. man "$@"
  520. }
  521. fi
  522. netwait(){
  523. while ! ping -c 1 -t 1 example.com
  524. do
  525. true
  526. done
  527. echo network works.
  528. }
  529. __realpath(){
  530. if type realpath >/dev/null 2>&1
  531. then
  532. command realpath "$@"
  533. else
  534. while ! test -d $1
  535. do
  536. shift
  537. done
  538. (command cd "$d" && echo "$PWD")
  539. # local d="$OLDPWD"
  540. # command cd "$1"
  541. # echo "$PWD"
  542. # command cd "$d"
  543. fi
  544. }
  545. if $isdarwin
  546. then
  547. # I want to use env -u, but darwin env does not provide this option
  548. __safe_alias tmux='SHLVL= tmux'
  549. else
  550. __safe_alias tmux='env -u SHLVL tmux'
  551. fi
  552. tx(){
  553. tmux start-server
  554. if test -z "$1"
  555. then
  556. echo "usage: tx <session_name>"
  557. tmux list-sessions
  558. elif test -z "$TMUX"
  559. then
  560. # -A: attach if already exists
  561. # tmux new-session -A -c "$HOME" -s "$1"
  562. tmux new-session -A -s "$1"
  563. else
  564. # create new session if not exists yet
  565. # tmux has-session -t "$1" || TMUX= tmux new-session -d -c "$HOME" -s "$1"
  566. tmux has-session -t "$1" || TMUX= tmux new-session -d -s "$1"
  567. tmux switch-client -t "$1"
  568. fi
  569. }
  570. dt(){
  571. # dt [-h] [<name>] [<command ...>]
  572. __dtach_dir="${TMP}/dtach"
  573. mkdir -p "${__dtach_dir}"
  574. if test -n "${__MY_DTACH}"
  575. then
  576. # if already in dtach session print current session
  577. soc_name="`basename "$__MY_DTACH"`"
  578. echo "Current session: ${soc_name}"
  579. fi
  580. if test -z "$1"
  581. then
  582. # if no arg given show list of sessions
  583. echo "Sessions:"
  584. ls "${__dtach_dir}"
  585. return 0
  586. elif test "$1" = "-h"
  587. then
  588. echo "dt: usage: dt [-h] [<name>] [<command ...>]" 1>&2
  589. return 1
  590. fi
  591. # set socket name
  592. soc_name="${__dtach_dir}/$1"
  593. shift
  594. if test -n "$__MY_DTACH"
  595. then
  596. echo "dtach session cannot be nested." 1>&2
  597. return 1
  598. elif test -S "$soc_name"
  599. then
  600. dtach -a "$soc_name" -e ^^
  601. elif test -e "$soc_name"
  602. then
  603. echo "dt: File named $soc_name already exists."
  604. return 1
  605. elif test -z "$1"
  606. then
  607. # if no command given invoke current shell
  608. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  609. # echo "dt: Socket named $soc_name not exists and no command specified."
  610. # return 1
  611. else
  612. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  613. fi
  614. }
  615. scr(){
  616. test -n "$1" && pf="${1}-"
  617. ___tformat="%Y%m%d-%H%M%S%z"
  618. ___file="${HOME}/${pf}`date +${___tformat}`.script"
  619. __MY_SCRIPT=${___file} script ${___file} "$@"
  620. }
  621. dtscr(){
  622. # dtscr <command ...>
  623. if test -z "$1"
  624. then
  625. echo "dtscr: usage: dtscr <command ...>"
  626. return 1
  627. fi
  628. ___cmdstr="`echo $@ | tr ' ' +`"
  629. ___tformat="%Y%m%d-%H%M%S%z"
  630. ___name="${pf}`date +${___tformat}`-${___cmdstr}"
  631. ___scr_file="${HOME}/${___name}.script"
  632. ___dt_dir="${TMP}/dtscr"
  633. mkdir -p "$___dt_dir"
  634. dtach -n "${___dt_dir}/${___name}" script "${___scr_file_}" "$@"
  635. # echo $_name
  636. # echo $_file
  637. }
  638. mcrypt_stream(){
  639. test $# -eq 2 || return 1
  640. case $1 in
  641. en)
  642. mcrypt --key $2 | base64 ;;
  643. de)
  644. base64 -d | mcrypt -d --key $2 ;;
  645. esac
  646. }
  647. gpg_stream(){
  648. test $# -eq 2 || return 1
  649. case $1 in
  650. en)
  651. gpg --passphrase $2 -c --batch |base64 ;;
  652. de)
  653. base64 -d|gpg --passphrase $2 -d --batch ;;
  654. esac
  655. }
  656. dgpg(){
  657. if test "$1" = help || test -z "$2"
  658. then
  659. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  660. return
  661. fi
  662. ___srcs="$2"
  663. ___dsts="$3"
  664. test -z "$___dsts" && ___dsts="${___srcs}.out"
  665. ___pw=
  666. echo -n "dgpg pw: "
  667. read -s ___pw
  668. echo ""
  669. test -z "$___pw" && return 1
  670. for f in *${___srcs}
  671. do
  672. ___d="$(basename "$f" "${___srcs}")${___dsts}"
  673. echo -n "Processing $f to $___d..."
  674. if test -d "$f"
  675. then
  676. echo "`printf 'failed (%s is directory)' $f`"
  677. elif test -f "$___d"
  678. then
  679. echo "`printf 'failed (%s is already exists)' $___d`"
  680. elif <"$f" gpg_stream $1 $___pw >"$___d" 2>/dev/null
  681. then
  682. echo "done"
  683. else
  684. echo "failed"
  685. test -f "$___d" && rm "$___d"
  686. fi
  687. done
  688. }
  689. alias enst="gpg_stream en"
  690. alias dest="gpg_stream de"
  691. showinfo(){
  692. echo "Japanese letters are 表示可能"
  693. __safe_run diskinfo
  694. ! $isdarwin && test -n "${DISPLAY}" && {
  695. __safe_run xrandr | \grep --color=never ^Screen
  696. }
  697. $iswindows || __safe_run finger $USER
  698. LANG=C __safe_runc id
  699. __safe_run xset q
  700. }
  701. x(){
  702. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  703. #mkdir -p ~/.var/log
  704. # nohup startx >~/.var/log/xorg.log 2>&1 &
  705. # exit
  706. exec startx
  707. else
  708. echo "X cant be started! Another X is already running?" 1>&2
  709. fi
  710. }
  711. bak(){
  712. for file in "$@"
  713. do
  714. cp -v ${file} ${file}.bak
  715. done
  716. }
  717. di(){
  718. if null type git
  719. then
  720. git --git-dir= diff "$@"
  721. ___diffcmd="git --git-dir= diff"
  722. else
  723. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  724. then
  725. ___diffcmd=colordiff
  726. else
  727. ___diffcmd=diff
  728. fi
  729. ${___diffcmd} -u "$@" | ${PAGER}
  730. fi
  731. }
  732. tb(){
  733. __datenum=`date +%Y%m%d-%H%M%S`
  734. __tb="$HOME/.var/tb/$__datenum"
  735. mkdir -p "$__tb"
  736. mv "$@" "$__tb"
  737. }
  738. mkdd(){
  739. _d=`date +%Y%m%d-%H%M%S` && \
  740. mkdir -p "$_d"
  741. }
  742. mkcd(){
  743. if test -z "$1"
  744. then
  745. echo "mkcd: usage: mkcd <dir>"
  746. return 1
  747. elif test -d "$1"
  748. then
  749. echo "Dir \"$1\" already exists."
  750. else
  751. mkdir -p "$1"
  752. echo "Dir \"$1\" created."
  753. fi
  754. cd "$1"
  755. }
  756. mkcdd(){
  757. # make and change date directory
  758. _d=`date +%Y%m%d-%H%M%S` && \
  759. mkcd "$_d"
  760. }
  761. if test -n "$TMUX" && null type reattach-to-user-namespace
  762. then
  763. alias pbpaste="reattach-to-user-namespace pbpaste"
  764. alias pbcopy="reattach-to-user-namespace pbcopy"
  765. fi
  766. catclip(){
  767. if $iswindows
  768. then
  769. cat /dev/clipboard | tr -d \\r
  770. elif $isdarwin
  771. then
  772. pbpaste
  773. else
  774. xclip -o -selection "clipboard"
  775. fi
  776. }
  777. setclip(){
  778. if test $# -eq 0
  779. then
  780. exec 3<&0
  781. else
  782. exec 3<<__EOF__
  783. `cat "$@"`
  784. __EOF__
  785. fi
  786. if $iswindows
  787. then
  788. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  789. elif $isdarwin
  790. then
  791. pbcopy 0<&3
  792. else
  793. 0<&3 xclip -i -f -selection "primary" | \
  794. xclip -i -f -selection "clipboard"
  795. fi
  796. exec 3<&-
  797. }
  798. open_file(){
  799. if $iscygwin
  800. then
  801. cygstart "$@"
  802. elif $ismsys
  803. then
  804. cmd.exe //c start "" "$@"
  805. elif $isdarwin
  806. then
  807. touch "$@"
  808. open "$@"
  809. elif $islinux
  810. then
  811. touch "$@"
  812. if null type pcmanfm; then
  813. LC_MESSAGES= pcmanfm "$@"
  814. else
  815. LC_MESSAGES= xdg-open "$@" &
  816. fi
  817. else
  818. cat "$@"
  819. fi
  820. }
  821. o(){
  822. if test $# -eq 0
  823. then
  824. open_file .
  825. else
  826. for f in "$@"
  827. do
  828. open_file "$(realpath "$f")"
  829. done
  830. fi
  831. }
  832. convmv_sjis2utf8_test(){
  833. convmv -r -f sjis -t utf8 *
  834. }
  835. convmv_sjis2utf8_notest(){
  836. convmv -r -f sjis -t utf8 * --notest
  837. }
  838. #################################################
  839. ## pastebin services
  840. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  841. sprunge(){
  842. # http://sprunge.us
  843. if test -z "$1"
  844. then
  845. curl -F 'sprunge=<-' http://sprunge.us
  846. else
  847. curl http://sprunge.us/$1
  848. fi
  849. }
  850. dpaste(){
  851. # http://dpaste.de
  852. if test -z "$1"
  853. then
  854. curl -F 'content=<-' https://dpaste.de/api/
  855. echo
  856. else
  857. curl https://dpaste.de/$1/raw/
  858. fi
  859. }
  860. ######################################
  861. ## Prompt Settings
  862. __my_moc_state(){
  863. type mocp >/dev/null 2>&1 || return
  864. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  865. printf "$1" "`mocp -Q %title 2>/dev/null`"
  866. }
  867. __my_parse_svn_branch() {
  868. ___svn_url=$(LANG=C svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  869. ___svn_repository_root=$(LANG=C svn info 2>/dev/null | \
  870. sed -ne 's#^Repository Root: ##p')
  871. echo ${___svn_url} | sed -e 's#^'"${___svn_repository_root}"'##g' | \
  872. awk '{print $1}'
  873. }
  874. __my_svn_ps1(){
  875. if svn status >/dev/null 2>&1
  876. then
  877. ___svn_branch=$(__my_parse_svn_branch)
  878. test -n "${___svn_branch}" && printf "$1" "{$___svn_branch}"
  879. fi
  880. }
  881. __my_battery_status(){
  882. ___dir=/sys/class/power_supply/BAT0
  883. if test -d $___dir && test -r $___dir/status && test -r $___dir/charge_full && \
  884. test -r $___dir/charge_now
  885. then
  886. ___st=$(cat $___dir/status)
  887. ___full=$(cat $___dir/charge_full)
  888. ___now=$(cat $___dir/charge_now)
  889. ___rate=$(expr "$___now" \* 100 / "$___full")
  890. printf "$1" "${___st}:${___rate}%"
  891. fi
  892. }
  893. alias bat='__my_battery_status %s\\n'
  894. __my_ps1_scale(){
  895. if null type stty && ! $ismsys
  896. then
  897. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  898. fi
  899. }
  900. __my_ps1_tmux(){
  901. null type tmux || return $last
  902. ___tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  903. test -n "$TMUX" && echo "[TMUX:$___tmuxc]"
  904. }
  905. __my_ps1_moc(){
  906. __my_moc_state "[MOC:%s]"
  907. }
  908. for f in /usr/share/git/git-prompt.sh \
  909. /Applications/Xcode.app/Contents/Developer/usr/share/git-core/git-prompt.sh \
  910. /usr/local/opt/bash-git-prompt/share/gitprompt.sh \
  911. /usr/share/git-core/contrib/completion/git-prompt.sh \
  912. /usr/local/share/git-core/contrib/completion/git-prompt.sh \
  913. /etc/bash_completion.d/git-prompt \
  914. /opt/local/share/git-core/git-prompt.sh \
  915. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  916. do
  917. test -r "$f" && ($inbash || $inzsh) && . "$f" && break
  918. done
  919. export GIT_PS1_SHOWDIRTYSTATE=t
  920. export GIT_PS1_SHOWUPSTREAM=t
  921. __my_ps1_git(){
  922. null type __git_ps1 || return $last
  923. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  924. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  925. }
  926. __printf_ipaddr(){
  927. # ipaddress <fmt>
  928. type ip >/dev/null 2>&1 || return 1
  929. ___ip=$(LANG=C ip addr show scope global | \
  930. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  931. test -n "$___ip" && printf "$1" $___ip
  932. }
  933. alias addr="__printf_ipaddr '%s'"
  934. __my_ps1_ipaddr(){
  935. ! $iswindows && __printf_ipaddr '[Addr:%s]'
  936. }
  937. __my_ps1_bttry(){
  938. ___bst="$__homerun/batterystatus"
  939. if test -z "$DISPLAY" && ! $iswindows
  940. then
  941. test -f $___bst && ___bstr="$(cat $___bst)"
  942. test -n "$___bstr" && ! echo $___bstr | grep 100 >/dev/null 2>&1 && \
  943. echo "[Battery:${___bstr}]"
  944. __my_battery_status %s >$___bst &
  945. fi
  946. }
  947. __my_ps1_memo(){
  948. test -f memo.txt && echo "m:`du -b memo.txt|cut -f 1`"
  949. }
  950. __my_ps1_dirs(){
  951. dirs | wc -l
  952. }
  953. __my_ps1_jobs(){
  954. # __my_ps1_jobs [<num>]
  955. if test -n "$1"
  956. then
  957. jobs="$1"
  958. else
  959. jobs="`jobs | wc -l`"
  960. fi
  961. if test "$jobs" -gt 0
  962. then
  963. echo "JOBS:$jobs"
  964. fi
  965. }
  966. __my_ps1_dollar(){
  967. if test -z "$SHLVL"
  968. then
  969. printf "$1"
  970. else
  971. perl -e 'while($ARGV[0]-- > 0){print "$ARGV[1]";}' $SHLVL "$1"
  972. fi
  973. }
  974. __my_alert_fail(){
  975. test $laststatus -eq 0 || \
  976. echo "STATUS:${laststatus}"
  977. }
  978. # About ansi escape sequences
  979. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  980. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  981. if $inbash || $inzsh
  982. then
  983. if $inzsh
  984. then
  985. __attr_beg=$'%{\033['
  986. __attr_end='m%}'
  987. else
  988. __attr_beg='\[\033['
  989. __attr_end='m\]'
  990. fi
  991. __color_default="${__attr_beg}0${__attr_end}"
  992. __color_black="${__attr_beg}0;30${__attr_end}"
  993. __color_red="${__attr_beg}0;31${__attr_end}"
  994. __color_green="${__attr_beg}0;32${__attr_end}"
  995. __color_yellow="${__attr_beg}0;33${__attr_end}"
  996. __color_blue="${__attr_beg}0;34${__attr_end}"
  997. __color_magenta="${__attr_beg}0;35${__attr_end}"
  998. __color_cyan="${__attr_beg}0;36${__attr_end}"
  999. __color_white="${__attr_beg}0;37${__attr_end}"
  1000. __color_light_black="${__attr_beg}1;30${__attr_end}"
  1001. __color_light_red="${__attr_beg}1;31${__attr_end}"
  1002. __color_light_green="${__attr_beg}1;32${__attr_end}"
  1003. __color_light_yellow="${__attr_beg}1;33${__attr_end}"
  1004. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  1005. __color_light_magenta="${__attr_beg}1;35${__attr_end}"
  1006. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  1007. __color_light_white="${__attr_beg}1;37${__attr_end}"
  1008. __color_bg_black="${__attr_beg}40${__attr_end}"
  1009. __color_bg_red="${__attr_beg}41${__attr_end}"
  1010. __color_bg_green="${__attr_beg}42${__attr_end}"
  1011. __color_bg_yellow="${__attr_beg}43${__attr_end}"
  1012. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1013. __color_bg_magenta="${__attr_beg}45${__attr_end}"
  1014. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1015. __color_bg_white="${__attr_beg}47${__attr_end}"
  1016. __attr_underline="${__attr_beg}4${__attr_end}"
  1017. __attr_reverse="${__attr_beg}7${__attr_end}"
  1018. __attr_bold="${__attr_beg}1${__attr_end}"
  1019. fi
  1020. # NOTE: tput is another easy way to set colors and background
  1021. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1022. # color blue.
  1023. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1024. if test "$TERM" != dumb
  1025. then
  1026. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1027. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1028. # color for ::
  1029. if test -z "$_HOSTCOLOR_1"
  1030. then
  1031. # default color used by tmux status line
  1032. _HOSTCOLOR_1=green
  1033. fi
  1034. eval "__my_c4=\${__color_light_${_HOSTCOLOR_1}}"
  1035. __my_c5="$__color_black$__color_bg_white" # color for SCR
  1036. __my_cdef="$__color_default"
  1037. fi
  1038. if $inbash
  1039. then
  1040. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1041. elif $inzsh
  1042. then
  1043. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1044. fi
  1045. __my_ps1_info1(){
  1046. # first line of PS1
  1047. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_moc)"
  1048. }
  1049. test -n "$__MY_SCRIPT" && \
  1050. __my_ps1_str_scr="SCR"
  1051. test -n "$SSH_CONNECTION" && \
  1052. __my_ps1_str_ssh="SSH"
  1053. test -n "$__MY_DTACH" && \
  1054. __my_ps1_str_dt="DT:`basename "$__MY_DTACH$"`"
  1055. __my_ps1_info2(){
  1056. # second line of PS1
  1057. echo $(__my_ps1_memo) $(__my_ps1_jobs) ${__my_ps1_str_scr} \
  1058. ${__my_ps1_str_ssh} ${__my_ps1_str_dt} $(__my_alert_fail) \
  1059. | sed -e 's/ /|/g'
  1060. }
  1061. __my_ps1_beg="${__my_c4}:: ${__my_cdef}"
  1062. __my_ps1_save_pos="\[\033[s\]"
  1063. __my_ps1_restore_pos="\[\033[u\]"
  1064. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1065. __my_ps1_move_15left="\[\033[15D\]"
  1066. # collapse when command line is too long and try to write over this string
  1067. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1068. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1069. if $inzsh
  1070. then
  1071. PROMPT="\
  1072. ${__my_ps1_beg}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info1)
  1073. ${__my_ps1_beg}\$(__my_ps1_info2) $(__my_ps1_dollar %#) "
  1074. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1075. elif $inbash
  1076. then
  1077. PS1="\
  1078. ${__my_ps1_beg}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info1)\n\
  1079. ${__my_ps1_beg}\D{%Y/%m/%d %H:%M} \$(__my_ps1_info2)${__my_ps1_right} $(__my_ps1_dollar \\$) "
  1080. else
  1081. true
  1082. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1083. fi
  1084. ###################################
  1085. # set header and titles
  1086. __my_set_header_line(){
  1087. # save current position
  1088. printf "\033[s"
  1089. # move to 0,0
  1090. printf "\033[0;0H"
  1091. # clear curent to eol
  1092. printf "\033[K"
  1093. # inverse color
  1094. printf "\033[7m"
  1095. printf "$1"
  1096. # restore color
  1097. printf "\033[0m"
  1098. # restore saved position
  1099. printf "\033[u"
  1100. }
  1101. __my_set_screen_name(){
  1102. # set window name
  1103. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1104. then
  1105. echo -ne "\033k$1\033\\"
  1106. fi
  1107. }
  1108. __my_set_title(){
  1109. case $TERM in
  1110. (rxvt*|xterm*|aterm|screen*)
  1111. test -t 1 &&
  1112. test -z "$EMACS" &&
  1113. echo -n -e "\033]0;$1\007"
  1114. ;;
  1115. esac
  1116. }
  1117. if test -n "$TMUX"
  1118. then
  1119. # running tmux locally
  1120. __terminal_title="\$(basename \${PWD})"
  1121. elif test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen' >/dev/null
  1122. then
  1123. # ssh connect from tmux terminal
  1124. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1125. else
  1126. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1127. fi
  1128. if $inzsh
  1129. then
  1130. precmd(){
  1131. laststatus=$?
  1132. eval __my_set_title ${__terminal_title}
  1133. }
  1134. else
  1135. if test -n "$PROMPT_COMMAND"
  1136. then
  1137. PROMPT_COMMAND="laststatus=\$?;$PROMPT_COMMAND;__my_set_title \"${__terminal_title}\""
  1138. else
  1139. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\""
  1140. fi
  1141. fi
  1142. laststatus=0